<?

#################################################################
#																#
#      OOPS  2001-2003 Andrey Lugovoy (440hz)					#
# CopyRight  2003 PeterService									#
#																#
# project   : www.billing.ru									#
# mailto    : andrey.lugovoy@billing.ru							#
#																#
#################################################################

### USERS.INC ###################################################

#   

define('USER_AUTH_GUEST',		0);
define('USER_AUTH_STANDART',	1);
define('USER_AUTH_LDAP',		2);

define('LOGIN_OK',				1);
define('LOGIN_L_ERROR',			2);
define('LOGIN_P_ERROR',			3);

define('FLAG_NEWS_COMPANY',		1);
define('FLAG_NEWS_INFO',		2);

define('FLAG_MSG_CUSTOMERS',	4);
define('FLAG_NTF_CUSTOMERS',	8);
define('FLAG_FTP2MAIL',			16);

define('FLAG_READONLY',			32);

class OOPSUser {
	var $uid;		# 
	var $name;		# 
	var $prefix;	# 
	var $namerus;	# 
	var $nick;		# nick
	var $org;		# 
	var $dep;		# 
	var $pos;		# 
	var $point;		#  
	var $db;		# 
	var $first;		# 
	var $last;		#  
	var $mail;		# 
	var $type;		#  
	var $allow;		#  

	function OOPSUser($db) {
		$this->uid = "0";
		$this->name = "Guest";
		$this->prefix = "";
		$this->namerus = "";
		$this->nick = "";
		$this->org = "";
		$this->dep = "";
		$this->pos = "";
		$this->point = "";
		$this->db = $db;
		$this->first = time();
		$this->last = time();
		$this->mail = "";
		$this->type = USER_AUTH_GUEST;
		$this->allow = array();
	}

	#    
	function Load($uid) {
		if(!empty($uid)) {
			if($this->db->CheckFields("OOPS_USERS","","ID = '".$uid."'")) {
				$obj = $this->db->ExtractObject();
				$this->uid = $uid;
				$this->point = $obj->POINT;
				$this->first = $obj->FIRST;
				$this->last = $obj->LAST;
				$this->mail = $obj->MAIL;
				$this->type = $obj->AUTHTYPE;
				$this->name = $obj->NAME;
				$this->prefix = $obj->PREFIX;
				$this->namerus = $obj->NAMERUS;
				$this->nick = $obj->NICK;
				$this->org = $obj->ORG;
				$this->pos = $obj->POS;

				$this->LoadAllows();
			}
		}
	}

	#    
	function GoToPoint() {

		if(!empty($this->point)) {
			OOPSRedir($this->point);
			return true;
		} else {
			return false;
		}
	}

	function GetName() {
		
		$rc = $this->name;

		if(!empty($this->namerus)) {
			$rc = $this->namerus;
		}

		if(!empty($this->nick))
			$rc .= " (".$this->nick.")";

		if(!empty($this->prefix))
			$rc = $this->prefix.": ".$rc;

		return $rc;
			
	}

	#    
	function Insert($l) {

		$this->uid = $this->db->GetFreeID("OOPS_USERS");

		$this->db->Query("INSERT INTO OOPS_USERS (ID,NAME,ORG,DEP,POS,PREFIX,LOGIN,POINT,FIRST,LAST,AUTHTYPE,MAIL) VALUES ('".$this->uid."','".$this->name."','".$this->org."','".$this->dep."','".$this->pos."','PS','".$l."','".$this->point."',".time().",".time().",".$this->type.",'".$this->mail."')");

		$this->db->Query("INSERT INTO OOPS_USERS2GROUPS (GID,UID) VALUES ('6073da4az2bf8mte','".$this->uid."')");

		$TIT = "  LDAP ";

		$TEXT = "";
		$TEXT .= "        : ".$this->name;
		$TEXT .= "\n";
		$TEXT .= "\n: ".$this->org;
		$TEXT .= "\n      : ".$this->dep;
		$TEXT .= "\n  : ".$this->pos;
		$TEXT .= "\n      : ".$this->mail;

		OOPSMailNotify($TIT,$TEXT);

	}

	#    LDAP
	function LDAPLogin($l,$p,$uid="0") {
		global $LDAP_SRV;
		global $LDAP_RDN;
		global $LDAP_PASS;
	
		return LOGIN_P_ERROR;
	}

	function Spy() {
		$this->db->Query("UPDATE OOPS_USERS SET LAST = ".time()." WHERE ID = '".$this->uid."'");
	}

	#    
	function Login($l,$p) {
		global $OOPSGlobal;

		#         ?
		if($this->db->CheckFields("OOPS_USERS","ID,NAME,NAMERUS,NICK,AUTHTYPE,POINT,MAIL","LOGIN = '".$l."' AND STATUS = 1")) {
			#     ID
			$obj = $this->db->ExtractObject();

			switch($obj->AUTHTYPE) {
				# 
				case USER_AUTH_STANDART:
					if($this->db->CheckFields("OOPS_USERS","","LOGIN = '".$l."' AND PASSW = password('".$p."')")) {
						$this->uid = $obj->ID;
						$this->name = $obj->NAME;
						$this->namerus = $obj->NAMERUS;
						$this->nick = $obj->NICK;
						$this->point = $obj->POINT;
						$this->mail = $obj->MAIL;

						$this->Spy();
						return LOGIN_OK;
					} else {
						return LOGIN_P_ERROR;
					}
				#   LDAP
				case USER_AUTH_LDAP:
					#   LDAP
					$rc = $this->LDAPLogin($l,$p,$obj->ID);
					if($rc == LOGIN_OK) {
						$this->uid = $obj->ID;
						$this->name = $obj->NAME;
						$this->namerus = $obj->NAMERUS;
						$this->nick = $obj->NICK;
#						$this->point = $obj->POINT;
#						$this->mail = $obj->MAIL;
					}
					$this->Update();

					#  ?
					$this->point = $obj->POINT;

					return $rc;
				default:
					#    ...
					return LOGIN_L_ERROR;
			}
		#   ...   ...
		} else {
			#    LDAP ?
			$rc = $this->LDAPLogin($l,$p);
			if($rc == LOGIN_OK) {
				$this->Insert($l);
				$this->Spy();
				return LOGIN_OK;
			#  .     -  
			} else {
				return LOGIN_L_ERROR;
			}
		}
	}
	
	# 
	function Update() {

		if($this->uid <> '0') {

			$this->db->Query("UPDATE OOPS_USERS SET NAME = '".$this->name."', NAMERUS = '".$this->namerus."', NICK = '".$this->nick."', ORG = '".$this->org."', DEP = '".$this->dep."', POS = '".$this->pos."', MAIL = '".$this->mail."' WHERE ID = '".$this->uid."'");
		}
	
	}


	#   
	function LoadAllows() {

		$SQL = "SELECT OOPS_ALLOWS.NAME FROM OOPS_USERS2GROUPS,OOPS_GROUPS,OOPS_GROUPS2ALLOWS,OOPS_ALLOWS WHERE OOPS_USERS2GROUPS.UID = '".$this->uid."' AND OOPS_USERS2GROUPS.GID = OOPS_GROUPS.ID AND OOPS_GROUPS.ID = OOPS_GROUPS2ALLOWS.GID AND OOPS_GROUPS2ALLOWS.AID = OOPS_ALLOWS.ID";

		$A = $this->db->QueryObjects($SQL);
		$AC = count($A);

		for($i=0;$i<$AC;$i++) {
			$AO = $A[$i];
			$this->allows[$AO->NAME] = true;
		}

	}
	
	#   
	function CheckAllow($ALLOW = '') {

		if(!empty($this->allows["Access2System"]))
			return true;

		if(!empty($this->allows[$ALLOW]))
			return true;

		return false;
	}

}

function LoadAllowsByID($db,$UID) {

	$SQL = "SELECT OOPS_ALLOWS.NAME FROM OOPS_USERS2GROUPS,OOPS_GROUPS,OOPS_GROUPS2ALLOWS,OOPS_ALLOWS WHERE OOPS_USERS2GROUPS.UID = '".$UID."' AND OOPS_USERS2GROUPS.GID = OOPS_GROUPS.ID AND OOPS_GROUPS.ID = OOPS_GROUPS2ALLOWS.GID AND OOPS_GROUPS2ALLOWS.AID = OOPS_ALLOWS.ID";

		$A = $db->QueryObjects($SQL);
		$AC = count($A);

		$ALLOWS = array();

		for($i=0;$i<$AC;$i++) {
			$AO = $A[$i];
			$ALLOWS[$AO->NAME] = true;
		}

		return $ALLOWS;

}

function CheckAllowByID($db,$UID,$ALLOW) {

	$SQL = "SELECT OOPS_ALLOWS.NAME FROM OOPS_USERS2GROUPS,OOPS_GROUPS,OOPS_GROUPS2ALLOWS,OOPS_ALLOWS WHERE OOPS_USERS2GROUPS.UID = '".$UID."' AND OOPS_USERS2GROUPS.GID = OOPS_GROUPS.ID AND OOPS_GROUPS.ID = OOPS_GROUPS2ALLOWS.GID AND OOPS_GROUPS2ALLOWS.AID = OOPS_ALLOWS.ID AND OOPS_ALLOWS.NAME = 'Access2System'";

	$A = $db->QueryObjects($SQL);
	$AC = count($A);

	if($AC == 1) return true;

	$SQL = "SELECT DISTINCT OOPS_ALLOWS.NAME FROM OOPS_USERS2GROUPS,OOPS_GROUPS,OOPS_GROUPS2ALLOWS,OOPS_ALLOWS WHERE OOPS_USERS2GROUPS.UID = '".$UID."' AND OOPS_USERS2GROUPS.GID = OOPS_GROUPS.ID AND OOPS_GROUPS.ID = OOPS_GROUPS2ALLOWS.GID AND OOPS_GROUPS2ALLOWS.AID = OOPS_ALLOWS.ID AND OOPS_ALLOWS.NAME = '".$ALLOW."'";

	$A = $db->QueryObjects($SQL);
	$AC = count($A);

	if($AC == 1) return true;
	
	return false;

}

?>